using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class CompanyConfiguration : IEntityTypeConfiguration<Company>
{
    public void Configure(EntityTypeBuilder<Company> builder)
    {

        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Name)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.CurrencyId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.Currency)
            .WithMany()
            .HasForeignKey(e => e.CurrencyId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.Property(e => e.TaxIdentification)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.BusinessLicense)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.CompanyLogo)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.StreetAddress)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.City)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.StateProvince)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.ZipCode)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Phone)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Email)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.SocialMediaLinkedIn)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SocialMediaX)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SocialMediaFacebook)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SocialMediaInstagram)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.SocialMediaTikTok)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.OtherInformation1)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.OtherInformation2)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.OtherInformation3)
            .HasMaxLength(GlobalConsts.StringLengthMedium);


        builder.HasIndex(e => e.AutoNumber).IsUnique();
        builder.HasIndex(e => e.Name);
        builder.HasIndex(e => e.Email);
        builder.HasIndex(e => e.CurrencyId);
    }
}